## aevol 9.3.0

=== CMakeLists.txt ===
# ============================================================================
# Require minimal version of cmake
# ============================================================================
cmake_minimum_required(VERSION 3.11)
if(${CMAKE_VERSION} VERSION_GREATER "3.24")
  cmake_policy(VERSION 3.24)
endif()

# ============================================================================
# Mac OS specific: Since we cannot use AppleClang, try find and configure
# brew-installed clang automatically
# ============================================================================
if (APPLE)
  if (NOT DEFINED CMAKE_C_COMPILER OR NOT DEFINED CMAKE_CXX_COMPILER)
    message(WARNING
      "We've detected that you are using Mac OS but did not explicitly set the C and/or C++ compiler.\n"
      "We'll assume you have a brew-installed llvm and do our best to locate and use it.\n"
      "Visit https://aevol.fr/doc/install for more information.\n"
    )
    execute_process(
      COMMAND brew --prefix llvm
      OUTPUT_VARIABLE LLVM_PATH
      OUTPUT_STRIP_TRAILING_WHITESPACE
      ERROR_VARIABLE  LLVM_ERROR
    )
    if (NOT LLVM_ERROR STREQUAL "")
      message(FATAL_ERROR "${LLVM_ERROR}")
    endif ()
    if (NOT LLVM_PATH STREQUAL "")
      message("Found llvm: ${LLVM_PATH}")
    endif ()
    set(CMAKE_C_COMPILER "${LLVM_PATH}/bin/clang")
    set(CMAKE_CXX_COMPILER "${LLVM_PATH}/bin/clang++")
    set(CMAKE_EXE_LINKER_FLAGS "-L${LLVM_PATH}/lib/c++")
  endif ()
endif ()

# ============================================================================
# Set project name and languages
# ============================================================================
project(aevol VERSION 9.3.0 LANGUAGES C CXX)

# ============================================================================
# Use C++20
# ============================================================================
set(CMAKE_CXX_STANDARD 20)

# ============================================================================
# Check compiler compatibility
# ============================================================================
if (APPLE)
  # If compiler is AppleClang, issue message and exit
  if(CMAKE_C_COMPILER_ID STREQUAL "AppleClang" OR CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
    message(FATAL_ERROR "The configured compiler appears to be AppleClang, which is not capable of building Aevol.\n"
    "Have you forgotten to explicitly set the compiler?\n"
    "Try `cmake -DCMAKE_C_COMPILER=/usr/local/opt/llvm/bin/clang -DCMAKE_CXX_COMPILER=/usr/local/opt/llvm/bin/clang++ ..`\n"
    "(note that you will probably have to run that command twice because of the way cmake handles cache)\n"
    "Visit https://aevol.fr/doc/install for more information.\n")
  endif ()
  # If compiler is GCC, version >=14 is required on Apple
  if(CMAKE_C_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "14")
      message(FATAL_ERROR "The configured compiler appears to be gcc < 14, which is not capable of building Aevol.\n"
        "Please upgrade to version 14 or higher.\n"
        "Visit https://aevol.fr/doc/install for more information.\n")
    endif ()
  endif ()
endif ()

# If compiler is Clang, version >=19 is required
if(CMAKE_C_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "19")
    message(FATAL_ERROR "The configured compiler appears to be clang < 19, which is not capable of building Aevol.\n"
      "Please upgrade to version 19 or higher.\n"
      "Visit https://aevol.fr/doc/install for more information.\n")
  endif ()
endif ()
# If compiler is GCC, version >=13 is required
if(CMAKE_C_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "13")
    message(FATAL_ERROR "The configured compiler appears to be gcc < 13, which is not capable of building Aevol.\n"
      "Please upgrade to version 13 or higher.\n"
      "Visit https://aevol.fr/doc/install for more information.\n")
  endif ()
endif ()

# Check existence of std::from_chars for type double
include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
  #include <charconv>
  int main() {
      double d;
      char const c[] = \"0\";
      std::from_chars(c, c+1, d);
      return 0;
  }
" HAS_FROMCHARS_DOUBLE)
if(HAS_FROMCHARS_DOUBLE)
  add_compile_definitions(HAS_FROMCHARS_DOUBLE)
endif ()

# Set a default build type to 'Release' if none was specified
IF(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  MESSAGE(STATUS "Setting build type to 'Release' as none was specified.")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
ENDIF()

set(AUTHORIZED_MTPERIOD 607 1279 2281 4253 11213 19937 44497 86243 132049 216091)

set(with-post-treatments ON CACHE BOOL "Whether to build post-treatments")

set(with-omp ON CACHE BOOL "Whether to enable OpenMP parallelization")

set(enable-profiling OFF CACHE BOOL "Whether to enable profiling")
set(with-tracing OFF CACHE BOOL "Whether to use tracing")
set(enable-perflog OFF CACHE BOOL "Whether to active performance log")
set(enable-normalized-fitness OFF CACHE BOOL "With this option, the NORMALIZED_FITNESS flag is defined, allowing a different fitness calculation")
set(enable-mtperiod 607 CACHE STRING "Period of the Mersen Twister. Autorized values are : 607 1279 2281 4253 11213 19937 44497 86243 132049 216091")
set(enable-trivialjumps OFF CACHE STRING "When this option is set, a trivial jump algorithm will be used instead of the polynomial-based method")
set(enable-omp-sort "" CACHE STRING "Which sorting algorithm to use for sorting mutant individual before processing them (by default, no sorting)")
set(dna-factory-alg "L2G" CACHE STRING "Which memory allocation algorithm to use for managing the DnaFactory pool of DNAs")

set(with-triangle OFF CACHE BOOL "Whether to enable triangle phenotypic target (else Gaussian)")
set(with-detectclone ON CACHE BOOL "Whether to enable clones and not recompute them")
set(with-floatconcentration OFF CACHE BOOL "Whether to enable the encoding of concentration has float (and not double)")
set(with-perf-traces OFF CACHE BOOL "Whether to activate performance traces of Aevol")
set(with-indiv-perf-traces OFF CACHE BOOL "Whether to activate performance traces (per individual) of Aevol")

set(search-type "OLD" CACHE STRING "Which SIMD pattern search version of Aevol")
set(with-opt-diff-search OFF CACHE BOOL "Activate the optimize version of differential search for motifs (RNA and Genes)")

set(with-progeny-stats OFF CACHE BOOL "Activate (or not) stats for progeny (should generate a lot of data)")

if ( ${with-indiv-perf-traces} )
        add_definitions(-DWITH_PERF_TRACES_PER_INDIV)
endif ()


if ( ${with-progeny-stats} )
	add_definitions(-DPROGENY_STATS)
endif ()

if ( ${with-omp} )
    find_package(OpenMP REQUIRED)

    if ( OPENMP_FOUND )
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    endif ()
endif ()

if ( ${enable-profiling} )
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pg")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
endif ()

if ( ${with-tracing} )
	add_definitions(-D__TRACING__)
endif ()

if ( ${enable-perflog} )
    add_definitions(-D__PERF_LOG__)
endif ()

if ( ${with-perf-traces} )
    add_definitions(-DWITH_PERF_TRACES)
endif ()

if ( ${with-opt-diff-search} )
    add_definitions(-DWITH_OPTIMIZE_DIFF_SEARCH)
endif ()

if ( ${enable-normalized-fitness} )
    add_definitions(-DNORMALIZED_FITNESS)
endif ()

if ( DEFINED enable-mtperiod )
    list(FIND AUTHORIZED_MTPERIOD ${enable-mtperiod} _index)
    if ( ${_index} GREATER -1 )
        set(MTPERIOD ${enable-mtperiod})
    else ()
        message(FATAL_ERROR "period is not a valid Mersenne Twister period")
    endif ()
endif ()
message("Mersene Twister period is set to ${MTPERIOD}")
add_definitions(-DSFMT_MEXP=${MTPERIOD})

if ( ${enable-trivialjumps} )
    if ( ${enable-trivialjumps} MATCHES "[0-9]+" )
        add_definitions(-DTRIVIAL_METHOD_JUMP_SIZE=${enable-trivialjumps})
    else ()
        add_definitions(-DTRIVIAL_METHOD_JUMP_SIZE=1000)
    endif ()
endif ()

if ( ${with-triangle} )
    add_definitions(-DPHENOTYPIC_TARGET_TRIANGLE)
endif ()

if ( ${with-detectclone} )
    add_definitions(-D__DETECT_CLONE)
endif ()

if ( ${with-floatconcentration} )
    add_definitions(-D__FLOAT_CONCENTRATION)
endif ()

if ( NOT ${enable-omp-sort} STREQUAL "" )
    if ( ${enable-omp-sort} STREQUAL "LDNA" )
        add_definitions(-D__OMP_LIST_SORT=0)
    elseif( ${enable-omp-sort} STREQUAL "SHUFFLE" )
        add_definitions(-D__OMP_LIST_SORT=1)
    endif ()
endif ()

if ( ${dna-factory-alg} STREQUAL "FIRST" )
    add_definitions(-D__DNA_FACTORY_ALG=0)
elseif ( ${dna-factory-alg} STREQUAL "FIRSTFIT" )
    add_definitions(-D__DNA_FACTORY_ALG=1)
elseif ( ${dna-factory-alg} STREQUAL "L2G" )
    add_definitions(-D__DNA_FACTORY_ALG=2)
elseif ( ${dna-factory-alg} STREQUAL "ALLOCATE" )
    add_definitions(-D__DNA_FACTORY_ALG=3)
endif ()

# ===========================================================================
# Tell CMake to export compile commands for IDE integration
# ===========================================================================
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# ===========================================================================
# Fetch external dependencies
# ===========================================================================
include(FetchContent)
FetchContent_Declare(
    json
    URL      https://github.com/nlohmann/json/releases/download/v3.12.0/json.tar.xz
    URL_HASH SHA256=42f6e95cad6ec532fd372391373363b62a14af6d771056dbfc86160e6dfff7aa
)
Message(STATUS "Getting external dependencies...")
FetchContent_MakeAvailable(json)
Message(STATUS "Getting external dependencies... Done")

# ============================================================================
# Look for Zlib
# ============================================================================
find_package(ZLIB REQUIRED)


# ============================================================================
# Get GNU standard installation directories (GNUInstallDirs module)
# ============================================================================
include(GNUInstallDirs)


# ============================================================================
# Tell CMake where to look for custom modules
# ============================================================================
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)


# ============================================================================
# Tell cmake where to put binary files.
# By GNU standards "executable programs that users can run" should go in
# bindir a.k.a ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}
# and "executable programs to be run by other programs rather than by users"
# in libexecdir a.k.a ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}
# ============================================================================
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})


# ============================================================================
# Set build type specific compilation flags
# ============================================================================
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -Wall -Wextra -Werror")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -Wall -Wextra -Werror")

set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -pipe")
if (CMAKE_C_COMPILER_ID MATCHES "GNU")

=== src/CMakeLists.txt ===
# ============================================================================
# List aevol main binaries
# ============================================================================
set(AEVOL_BINS create run)


# Set dummy targets to be used by the user when they want to build a subset of
# aevol flavors, e.g. `make aevol_4b`
# Dependencies will be added to these targets as we define them
foreach (AEVOL_FLAVOR IN LISTS AEVOL_FLAVORS)
  add_custom_target(${AEVOL_FLAVOR})
endforeach (AEVOL_FLAVOR)

# ============================================================================
# Tell cmake about subdirectories to look into
# ============================================================================
add_subdirectory(libaevol)

if (with-post-treatments)
  add_subdirectory(post_treatments)
endif()

# ============================================================================
# Add targets add their dependencies
# ============================================================================
foreach (AEVOL_RAW_FLAVOR IN LISTS AEVOL_RAW_FLAVORS)
  foreach (AEVOL_BIN IN LISTS AEVOL_BINS)
    set(FLAVORED_BIN_NAME aevol_${AEVOL_BIN}_${AEVOL_RAW_FLAVOR})
    add_executable(${FLAVORED_BIN_NAME} aevol_${AEVOL_BIN}.cpp)
    target_link_libraries(${FLAVORED_BIN_NAME} PUBLIC libaevol_${AEVOL_RAW_FLAVOR})
    add_dependencies(aevol_${AEVOL_RAW_FLAVOR} ${FLAVORED_BIN_NAME})
  endforeach (AEVOL_BIN)
endforeach (AEVOL_RAW_FLAVOR)

# ============================================================================
# Set behaviour on make install
# ============================================================================
foreach (AEVOL_RAW_FLAVOR IN LISTS AEVOL_RAW_FLAVORS)
  install(TARGETS aevol_create_${AEVOL_RAW_FLAVOR})
  install(TARGETS aevol_run_${AEVOL_RAW_FLAVOR})
endforeach (AEVOL_RAW_FLAVOR)

=== test/CMakeLists.txt ===
# Add gtest tests
add_subdirectory(gtest)

# Add Ctest tests
add_subdirectory(ctest)

=== src/libaevol/CMakeLists.txt ===
# ============================================================================
# Tell cmake about subdirectories to look into
# ============================================================================
add_subdirectory(SFMT-src-1.4)

# ============================================================================
# Add targets add their dependencies
# ============================================================================
set(libaevol_sources
  ae_types.h
  AeTime.cpp
  AeTime.h
  aevol.h
  macros.h

  aevol_flavor.h
  aevol_version.h

  alignments/Alignment.h
  alignments/AlignmentParams.cpp
  alignments/AlignmentParams.h
  alignments/FunctionShape.h
  alignments/RecombAlignmentSearcher.cpp
  alignments/RecombAlignmentSearcher.h
  alignments/ScoreFunction.cpp
  alignments/ScoreFunction.h
  biochemistry/AnnotatedChromosome.h
  biochemistry/AnnotatedChromosome.cpp
  biochemistry/Codon.cpp
  biochemistry/Codon.h
  biochemistry/Dna.cpp
  biochemistry/Dna.h
  biochemistry/DnaFactory.cpp
  biochemistry/DnaFactory.h
  biochemistry/fuzzytypes.h
  biochemistry/GenomeLimits.h
  biochemistry/mutations/MutationEvent.cpp
  biochemistry/mutations/MutationEvent.h
  biochemistry/mutations/MutationMetrics.h
  biochemistry/mutations/MutationParams.cpp
  biochemistry/mutations/MutationParams.h
  biochemistry/mutations/mutators/DnaMutator.cpp
  biochemistry/mutations/mutators/DnaMutator.h
  biochemistry/mutations/mutators/IndividualMutator.h
  biochemistry/Promoter.cpp
  biochemistry/Promoter.h
  biochemistry/PromoterList.cpp
  biochemistry/PromoterList.h
  biochemistry/Protein.cpp
  biochemistry/Protein.h
  biochemistry/ProteinList.cpp
  biochemistry/ProteinList.h
  biochemistry/Rna.cpp
  biochemistry/Rna.h
  biochemistry/RnaList.cpp
  biochemistry/RnaList.h
  biochemistry/Strand.h
  biochemistry/TranscriptionTerminationSequence.cpp
  biochemistry/TranscriptionTerminationSequence.h
  biochemistry/TranslationInitiationSequence.cpp
  biochemistry/TranslationInitiationSequence.h
  Chrsm.h
  ExpSetup.cpp
  ExpSetup.h
  io/checkpointing/CheckpointData.h
  io/checkpointing/CheckpointHandler.cpp
  io/checkpointing/CheckpointHandler.h
  io/checkpointing/mxifstream.cpp
  io/checkpointing/mxifstream.h
  io/checkpointing/mxofstream.cpp
  io/checkpointing/mxofstream.h
  io/fasta/fasta.cpp
  io/fasta/fasta.h
  io/fasta/FastaModifiers.cpp
  io/fasta/FastaModifiers.h
  io/fasta/FastaReader.cpp
  io/fasta/FastaReader.h
  io/fasta/FastaWriter.cpp
  io/fasta/FastaWriter.h
  io/indiv_idxs_map.h
  io/last_gener.h
  io/parameters/ParamReader.cpp
  io/parameters/ParamReader.h
  io/parameters/ParamValues.cpp
  io/parameters/ParamValues.h
  io/stats/AbstractStatsHandler.h
  io/stats/AbstractSingleIndividualStatsHandler.h
  io/stats/SingleIndividualStatsHandler.h
  io/stats/MultiIndividualDataCollector.h
  io/stats/MeanStatsHandler.h
  io/stats/StatsDataConcepts.h
  io/stats/ChromosomeStatsData.h
  io/stats/DiploidChromosomeStatsData.h
  io/stats/DefaultGlobalStatsData.h
  io/stats/FitnessStatsData.h
  io/stats/MutationsStatsData.h
  io/stats/DiploidMutationsStatsData.h
  io/stats/NonCodingStatsData.h
  io/stats/DiploidNonCodingStatsData.h
  io/stats/StatsOrchestrator.cpp
  io/stats/StatsOrchestrator.h
  io/tree/mutation_report/Deletion.cpp
  io/tree/mutation_report/Deletion.h
  io/tree/mutation_report/Duplication.cpp
  io/tree/mutation_report/Duplication.h
  io/tree/mutation_report/HorizontalTransfer.h
  io/tree/mutation_report/InsertionHT.cpp
  io/tree/mutation_report/InsertionHT.h
  io/tree/mutation_report/Inversion.cpp
  io/tree/mutation_report/Inversion.h
  io/tree/mutation_report/LocalMutation.h
  io/tree/mutation_report/MutationReport.cpp
  io/tree/mutation_report/MutationReport.h
  io/tree/mutation_report/PointMutation.cpp
  io/tree/mutation_report/PointMutation.h
  io/tree/mutation_report/Rearrangement.h
  io/tree/mutation_report/ReplacementHT.cpp
  io/tree/mutation_report/ReplacementHT.h
  io/tree/mutation_report/SmallDeletion.cpp
  io/tree/mutation_report/SmallDeletion.h
  io/tree/mutation_report/SmallInsertion.cpp
  io/tree/mutation_report/SmallInsertion.h
  io/tree/mutation_report/Translocation.cpp
  io/tree/mutation_report/Translocation.h
  io/tree/PhylogeneticTreeHandler.cpp
  io/tree/PhylogeneticTreeHandler.h
  io/tree/Tree.cpp
  io/tree/Tree.h
  io/ui/UserInterfaceOutput.cpp
  io/ui/UserInterfaceOutput.h
  io/tree/DnaReplicationReport.cpp
  io/tree/DnaReplicationReport.h
  io/tree/ReplicationReport.cpp
  io/tree/ReplicationReport.h
  orchestration/CheckpointExplorer.cpp
  orchestration/CheckpointExplorer.h
  orchestration/EvolutionRunner.cpp
  orchestration/EvolutionRunner.h
  orchestration/ExperimentCreator.cpp
  orchestration/ExperimentCreator.h
  orchestration/IndividualAnalyser.cpp
  orchestration/IndividualAnalyser.h
  phenotype/fuzzy/AbstractFuzzy.h
  phenotype/fuzzy/FuzzyFactory.cpp
  phenotype/fuzzy/FuzzyFactory.h
  phenotype/fuzzy/FuzzyFlavor.h
  phenotype/fuzzy/Discrete_Double_Fuzzy.cpp
  phenotype/fuzzy/Discrete_Double_Fuzzy.h
  phenotype/fuzzy/FuzzyHelpers.cpp
  phenotype/fuzzy/FuzzyHelpers.h
  phenotype/fuzzy/Vector_Fuzzy.h
  phenotype/fuzzy/Vector_Fuzzy.cpp
  phenotype/Gaussian.h
  phenotype/PhenotypicTarget.cpp
  phenotype/PhenotypicTarget.h
  phenotype/Point.cpp
  phenotype/Point.h

  population/Grid.cpp
  population/Grid.h
  population/GridCell.cpp
  population/GridCell.h
  population/Individual.cpp
  population/Individual.h
  population/Population.cpp
  population/Population.h
  population/Selection.cpp
  population/Selection.h
  population/SelectionParams.cpp
  population/SelectionParams.h

        rng/JumpingMT.cpp
  rng/JumpingMT.h
  rng/JumpPoly.h
  #rng/MersenneTwister.cpp
  #rng/MersenneTwister.h
  utils/utils.cpp
  utils/utils.h
  utils/utility.h
  )

# Eukaryote/Prokaryote specifics
set(libaevol_prokaryote_sources
    biochemistry/mutations/mutators/ProkaryoteIndividualMutator.cpp
    biochemistry/mutations/mutators/ProkaryoteIndividualMutator.h
)
set(libaevol_eukaryote_sources
    biochemistry/mutations/mutators/EukaryoteIndividualMutator.cpp
    biochemistry/mutations/mutators/EukaryoteIndividualMutator.h
)

# Aevol_4b specifics
set(libaevol_4b_specific_sources
    aevol_4b/biochemistry/AminoAcid.h
    aevol_4b/biochemistry/AA_2_MWH_Value_Mapping.cpp
    aevol_4b/biochemistry/AA_2_MWH_Value_Mapping.h)

# Combine 2b/4b with eukaryote/prokaryote
set(libaevol_2b_sources           ${libaevol_sources} ${libaevol_prokaryote_sources})
set(libaevol_eukaryote_2b_sources ${libaevol_sources} ${libaevol_eukaryote_sources})
set(libaevol_4b_sources           ${libaevol_sources} ${libaevol_prokaryote_sources}  ${libaevol_4b_specific_sources})
set(libaevol_eukaryote_4b_sources ${libaevol_sources} ${libaevol_eukaryote_sources}   ${libaevol_4b_specific_sources})

foreach (AEVOL_FLAVOR IN LISTS AEVOL_FLAVORS)
  set(lib${AEVOL_FLAVOR}_sources ${lib${AEVOL_FLAVOR}_sources} ${AEVOL_FLAVOR}_flavor.cpp)
  configure_file(aevol_flavor.cpp.in ${CMAKE_CURRENT_BINARY_DIR}/${AEVOL_FLAVOR}_flavor.cpp)
endforeach ()

# ============================================================================
# Generate version file aevol_version.cpp
# ============================================================================
configure_file(aevol_version.cpp.in ${CMAKE_CURRENT_BINARY_DIR}/aevol_version.cpp.in @ONLY)

# Configure further at build time
add_custom_target(generate-aevol-version
  BYPRODUCTS ${CMAKE_CURRENT_BINARY_DIR}/aevol_version.cpp
  COMMAND ${CMAKE_COMMAND}
      -DAEVOL_SOURCE_DIR=${aevol_SOURCE_DIR}
      -P ${aevol_SOURCE_DIR}/CMakeScripts/aevol_version.cmake
  COMMENT "Generating ${CMAKE_CURRENT_BINARY_DIR}/aevol_version.cpp"
)
add_library(libaevol-version ${CMAKE_CURRENT_BINARY_DIR}/aevol_version.cpp)
add_dependencies(libaevol-version generate-aevol-version)
set_target_properties(libaevol-version PROPERTIES PREFIX "")

# ============================================================================
# Add libaevol for each flavor of aevol
# ============================================================================
foreach (AEVOL_FLAVOR IN LISTS AEVOL_FLAVORS)
  add_library(lib${AEVOL_FLAVOR} ${lib${AEVOL_FLAVOR}_sources})
  set_target_properties(lib${AEVOL_FLAVOR} PROPERTIES PREFIX "")
  target_link_libraries(lib${AEVOL_FLAVOR} PUBLIC libaevol-version)
  target_link_libraries(lib${AEVOL_FLAVOR} PRIVATE OpenMP::OpenMP_CXX)
  target_link_libraries(lib${AEVOL_FLAVOR} PRIVATE nlohmann_json::nlohmann_json)
  add_dependencies(${AEVOL_FLAVOR} lib${AEVOL_FLAVOR})
endforeach(AEVOL_FLAVOR)

# Additional flavor-specific settings
if (TARGET libaevol_2b)
  target_compile_definitions(libaevol_2b PUBLIC BASE_2)
endif ()
if (TARGET libaevol_4b)
  target_compile_definitions(libaevol_4b PUBLIC BASE_4)
endif ()
if (TARGET libaevol_eukaryote_2b)
  target_compile_definitions(libaevol_eukaryote_2b PUBLIC BASE_2)
  target_compile_definitions(libaevol_eukaryote_2b PUBLIC LINEAR_CHRSM DIPLOID SEX)
endif ()
if (TARGET libaevol_eukaryote_4b)
  target_compile_definitions(libaevol_eukaryote_4b PUBLIC BASE_4)
  target_compile_definitions(libaevol_eukaryote_4b PUBLIC LINEAR_CHRSM DIPLOID SEX)
endif ()

# ============================================================================
# Include directories
# ============================================================================
foreach (AEVOL_FLAVOR IN LISTS AEVOL_FLAVORS)
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC ".")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "./alignments")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "./biochemistry")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "./biochemistry/mutations")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "./gui")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "./io")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "io/tree/mutation_report")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "./phenotype")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "./population")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "./rng")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "./SFMT-src-1.4")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "legacy/stats")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "./utils")
  target_include_directories(lib${AEVOL_FLAVOR} PUBLIC "./world")
endforeach(AEVOL_FLAVOR)


# ============================================================================
# Use GSL and zlib
# ============================================================================
foreach (AEVOL_FLAVOR IN LISTS AEVOL_FLAVORS)
  target_link_libraries(lib${AEVOL_FLAVOR} PRIVATE ZLIB::ZLIB)
  target_link_libraries(lib${AEVOL_FLAVOR} PUBLIC sfmt)
endforeach(AEVOL_FLAVOR)


# ============================================================================
# Make STDC MACROS available (for fixed width integers)
# ============================================================================
foreach (AEVOL_FLAVOR IN LISTS AEVOL_FLAVORS)
  target_compile_definitions(lib${AEVOL_FLAVOR}
    PUBLIC __STDC_FORMAT_MACROS
    PUBLIC __STDC_CONSTANT_MACROS)
endforeach(AEVOL_FLAVOR)

=== src/post_treatments/CMakeLists.txt ===
# ===== List aevol-flavor-independent post_treatments
set(AEVOL_POST_TREATMENTS
    extract_genomes
    make_ui_output_from_checkpoint
    make_ui_output_from_fasta
    )

# ========== Add prokaryote-specific post_treatments
set(AEVOL_PROKARYOTE_POST_TREATMENTS
    ancestor_stats
    lineage
    mutagenesis
    replicative_robustness
)

# ========== Add targets add their dependencies
macro(add_post_treatment RAW_FLAVOR POST_TREATMENT)
  set(FLAVORED_BIN_NAME aevol_post_${POST_TREATMENT}_${RAW_FLAVOR})
  add_executable(${FLAVORED_BIN_NAME} ${POST_TREATMENT}.cpp)
  target_link_libraries(${FLAVORED_BIN_NAME} PUBLIC libaevol_${RAW_FLAVOR})
  add_dependencies(aevol_${RAW_FLAVOR} ${FLAVORED_BIN_NAME})
  set(ALL_POST_TREATMENTS ${ALL_POST_TREATMENTS} ${FLAVORED_BIN_NAME})
endmacro()

# aevol-flavor-independent
foreach (AEVOL_RAW_FLAVOR IN LISTS AEVOL_RAW_FLAVORS)
  foreach (AEVOL_POST_TREATMENT IN LISTS AEVOL_POST_TREATMENTS)
    add_post_treatment(${AEVOL_RAW_FLAVOR} ${AEVOL_POST_TREATMENT})
  endforeach (AEVOL_POST_TREATMENT)
endforeach (AEVOL_RAW_FLAVOR)
# prokaryote-specific
foreach (AEVOL_PROKARYOTE_RAW_FLAVOR IN LISTS AEVOL_PROKARYOTE_RAW_FLAVORS)
  foreach (AEVOL_POST_TREATMENT IN LISTS AEVOL_PROKARYOTE_POST_TREATMENTS)
    add_post_treatment(${AEVOL_PROKARYOTE_RAW_FLAVOR} ${AEVOL_POST_TREATMENT})
  endforeach (AEVOL_POST_TREATMENT)
endforeach (AEVOL_PROKARYOTE_RAW_FLAVOR)

# ========== Set behaviour on make install
foreach (POST_TREATMENT IN LISTS ALL_POST_TREATMENTS)
  install(TARGETS ${POST_TREATMENT})
endforeach ()

=== test/ctest/CMakeLists.txt ===
########## Check example parameter files (checks only the return value -> SUCCESS/FAILURE)
# Basic
add_test(
    NAME    check_basic_example_param_file
    COMMAND aevol_create_2b ${PROJECT_SOURCE_DIR}/examples/basic/param.in)
set_tests_properties(
    check_basic_example_param_file
    PROPERTIES LABELS "TEST;aevol_2b;example_param_files")
# Virus
add_test(
    NAME    check_virus_example_param_file
    COMMAND aevol_create_2b ${PROJECT_SOURCE_DIR}/examples/virus/param.in)
set_tests_properties(
    check_virus_example_param_file
    PROPERTIES LABELS "TEST;aevol_2b;example_param_files")
# Eukaryote. Contains 2 param files: one for the prokaryotic bootstrap and one for the acual eukaryote experiment
add_test(
    NAME    check_eukaryote_bootstrap_example_param_file
    COMMAND aevol_create_2b ${PROJECT_SOURCE_DIR}/examples/eukaryote/prokaryote_bootstrap/param.in)
set_tests_properties(
    check_eukaryote_bootstrap_example_param_file
    PROPERTIES LABELS "TEST;aevol_2b;example_param_files")
add_test(
    NAME    check_eukaryote_example_param_file
    COMMAND aevol_create_eukaryote_2b ${PROJECT_SOURCE_DIR}/examples/eukaryote/param.in --fasta ${PROJECT_SOURCE_DIR}/examples/eukaryote/WT0.fa)
set_tests_properties(
    check_eukaryote_example_param_file
    PROPERTIES LABELS "TEST;aevol_eukaryote_2b;example_param_files")

=== test/gtest/CMakeLists.txt ===
include(GoogleTest)

set(BUILD_GMOCK OFF)
set(INSTALL_GTEST OFF)

FetchContent_Declare(
    googletest
    GIT_REPOSITORY https://github.com/google/googletest.git
    GIT_TAG        v1.14.0
)
Message(STATUS "Getting external dependency (googletest)...")
FetchContent_MakeAvailable(googletest)
Message(STATUS "Getting external dependency (googletest)... Done")

function(add_gtest
    test
    aevol_flavor)
  # Setup optional WORKING_DIRECTORY argument
  set(options "")
  set(oneValueArgs WORKING_DIRECTORY)
  set(multiValueArgs "")
  cmake_parse_arguments(PARSE_ARGV 2 arg
      "${options}" "${oneValueArgs}" "${multiValueArgs}"
  )

  # Add test binary and link it to libaevol and gtest_main
  add_executable(${test} ${test}.cpp)
  target_link_libraries(${test} PRIVATE GTest::gtest_main lib${aevol_flavor})

  # Add test (optionally setting work_dir)
  if(arg_WORKING_DIRECTORY)
    gtest_add_tests(
        TARGET ${test}
        WORKING_DIRECTORY ${arg_WORKING_DIRECTORY}
        TEST_PREFIX "[GTEST] "
        TEST_LIST ${test}_TESTS
    )
  else ()
    gtest_add_tests(
        TARGET ${test}
        TEST_PREFIX "[GTEST] "
        TEST_LIST ${test}_TESTS
    )
  endif ()

  # Add labels
  set_tests_properties(${${test}_TESTS}
      PROPERTIES
      LABELS "TEST;gtest;${aevol_flavor}")

  # Add test binary to target all-with-gtests
  add_dependencies(all-with-gtests ${test})

  # Tell caller about added tests and add to ALL_GTESTS
  set(${test}_TESTS ${${test}_TESTS} PARENT_SCOPE)
  set(ALL_GTESTS ${ALL_GTESTS} ${${test}_TESTS} PARENT_SCOPE)
endfunction()
##################################################

# Copy test data
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/test_data
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Add custom target to compile all flavors of aevol and all the gtests that will be added with function add_gtest
add_custom_target(all-with-gtests DEPENDS ${AEVOL_FLAVORS})

add_gtest(DnaTest                 aevol_2b)
add_gtest(JumpingMTTest           aevol_2b)
add_gtest(DiscreteDoubleFuzzyTest aevol_2b)
add_gtest(CheckpointExplorerTest  aevol_2b WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/test_data)
add_gtest(EvolutionRunnerTest     aevol_2b WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/test_data)
add_gtest(Dna_4bTest              aevol_4b)
add_gtest(FastaTest               aevol_4b)
add_gtest(Folding4bTest           aevol_4b)
add_gtest(EukIndividualTest       aevol_eukaryote_2b)
add_gtest(EukTest_mutations       aevol_eukaryote_2b)
add_gtest(EukTest_nornas          aevol_eukaryote_2b)
add_gtest(EukTest_withrnas        aevol_eukaryote_2b)

# Add pseudo-test to be used as a dependency to force the build of all-with-gtests before tests are run
add_test(build_all-with-gtests
    "${CMAKE_COMMAND}"
    --build "${CMAKE_BINARY_DIR}"
    --config "$<CONFIG>"
    --target all-with-gtests
)
set_tests_properties(${ALL_GTESTS}
    PROPERTIES
    DEPENDS build_all-with-gtests
)

# Add pseudo-test to be used as a dependency to generate test data
add_test(NAME generate_gtest_test_data
    COMMAND sh generate_data.sh
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/test_data
)
set_tests_properties(generate_gtest_test_data
    PROPERTIES
    DEPENDS build_all-with-gtests
)
set_tests_properties(${CheckpointExplorerTest_TESTS} ${EvolutionRunnerTest_TESTS}
    PROPERTIES
    DEPENDS generate_gtest_test_data
)

=== src/libaevol/SFMT-src-1.4/CMakeLists.txt ===
# ============================================================================
# Add targets add their dependencies
# ============================================================================
set(SFMT_params
  SFMT-params.h
  SFMT-params607.h
  SFMT-params1279.h
  SFMT-params2281.h
  SFMT-params4253.h
  SFMT-params11213.h
  SFMT-params19937.h
  SFMT-params44497.h
  SFMT-params86243.h
  SFMT-params132049.h
  SFMT-params216091.h)

add_library(sfmt
  SFMT.h
  SFMT.c
  jump/SFMT-jump.h
  jump/SFMT-jump.cpp
  SFMT-common.h
  ${SFMT_params})

target_include_directories(sfmt PUBLIC ".")


# ============================================================================
# Use GSL and zlib
# ============================================================================
target_link_libraries(sfmt PUBLIC ${ZLIB_LIBRARY})


# ============================================================================
# Make STDC MACROS available (for fixed width integers)
# ============================================================================
target_compile_definitions(sfmt
  PUBLIC __STDC_FORMAT_MACROS
  PUBLIC __STDC_CONSTANT_MACROS)


# ============================================================================
# Silence -Wunused-const-variable warning
# ============================================================================
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wno-unused-const-variable")

=== src/post_treatments/libaevol_post/CMakeLists.txt ===
# ============================================================================
# Libaevol-post is a library that contains classes shared by several
# post-treatments
# ============================================================================

foreach (AEVOL_FLAVOR IN LISTS AEVOL_FLAVORS)
  add_library(lib${AEVOL_FLAVOR}-post
      neutral_mutation_output.cpp
      neutral_mutation_output.h)
  target_link_libraries(lib${AEVOL_FLAVOR}-post PRIVATE lib${AEVOL_FLAVOR})
  set_target_properties(lib${AEVOL_FLAVOR}-post PROPERTIES PREFIX "")

  target_include_directories(lib${AEVOL_FLAVOR}-post PUBLIC ".")
endforeach (AEVOL_FLAVOR)

## aevol 4.2

=== debian/changelog ===
aevol (4.2-1) unstable; urgency=low

  * Initial release (Closes: #718887)

 -- David Parsons <david.parsons@inria.fr>  Fri, 22 Nov 2013 16:10:43 +0100

=== debian/control ===
Source: aevol
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: David Parsons <david.parsons@inria.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9.0),
               zlib1g-dev,
               autotools-dev,
               libx11-dev
Standards-Version: 3.9.4
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/aevol/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/aevol/trunk/
Homepage: http://www.aevol.fr/

Package: aevol
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: digital genetics model to run Evolution Experiments in silico
 Aevol is a digital genetics model: populations of digital organisms are
 subjected to a process of selection and variation, which creates a
 Darwinian dynamics.
 .
 By modifying the characteristics of selection (e.g. population size,
 type of environment, environmental variations) or variation (e.g.
 mutation rates, chromosomal rearrangement rates, types of
 rearrangements, horizontal transfer), one can study experimentally the
 impact of these parameters on the structure of the evolved organisms.
 In particular, since Aevol integrates a precise and realistic model of
 the genome, it allows for the study of structural variations of the
 genome (e.g. number of genes, synteny, proportion of coding sequences).
 .
 The simulation platform comes along with a set of tools for analysing
 phylogenies and measuring many characteristics of the organisms and
 populations along evolution.

## aevol 4.3

=== debian/changelog ===
aevol (4.3-1) unstable; urgency=low

  * New upstream version
  * Bumped Standards-Version to 3.9.5 (no changes needed)

 -- David Parsons <david.parsons@inria.fr>  Wed, 23 Apr 2014 15:18:40 +0100

## aevol 4.4

=== debian/changelog ===
aevol (4.4-1) unstable; urgency=low

  * New upstream version

 -- David Parsons <david.parsons@inria.fr>  Thu, 31 Jul 2014 23:58:27 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                zlib1g-dev,
                autotools-dev,
                libx11-dev
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/aevol/trunk/
 Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/aevol/trunk/
 Homepage: http://www.aevol.fr/

=== debian/watch ===
version=3
http://www.aevol.fr/download/index.php http://gforge.liris.cnrs.fr/frs/download.php/.*/aevol-(.*)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip)

## aevol 5.0

=== debian/changelog ===
aevol (5.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Moved packaging from SVN to Git
  * Fixed watch file
  * debhelper 10
  * Standards-Version: 4.1.0 (no changes needed)
  * Add missing libboost Build-Depends
  * hardening=+all
  * Unique license name

 -- Andreas Tille <tille@debian.org>  Mon, 11 Sep 2017 20:47:37 +0200

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,15 @@
 Uploaders: David Parsons <david.parsons@inria.fr>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9.0),
+Build-Depends: debhelper (>= 10),
                zlib1g-dev,
-               autotools-dev,
-               libx11-dev
-Standards-Version: 3.9.5
-Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/aevol/trunk/
-Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/aevol/trunk/
+               libx11-dev,
+               libboost-dev,
+               libboost-system-dev,
+               libboost-filesystem-dev
+Standards-Version: 4.1.0
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/aevol.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/aevol.git
 Homepage: http://www.aevol.fr/
 
 Package: aevol
@@ -33,4 +35,3 @@
  The simulation platform comes along with a set of tools for analysing
  phylogenies and measuring many characteristics of the organisms and
  populations along evolution.
-

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

=== debian/watch ===
version=4
http://www.aevol.fr/download/ https://gforge.inria.fr/frs/download.php/file/.*/aevol-(\d[.\d]+)@ARCHIVE_EXT@

## aevol 5.0%2Bds

=== debian/changelog ===
aevol (5.0+ds-4ubuntu4) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@debian.org>  Tue, 03 Feb 2026 21:36:46 +0100

aevol (5.0+ds-4ubuntu3) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:10:08 +0200

aevol (5.0+ds-4ubuntu2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:59:43 +0200

aevol (5.0+ds-4ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable (LP: #2098425). Remaining change:
    - debian/patches/fix-buffer-overflow.patch: avoid possible buffer
      overflows (LP: #2071412).

 -- Matthieu Clemenceau <matthieu.clemenceau@canonical.com>  Thu, 13 Feb 2025 23:54:15 +0000

aevol (5.0+ds-4) unstable; urgency=medium

  * Team upload.
  * d/control: migrate to mpi-default-dev. (Closes: #1088626)
  * d/watch: upstream forge moved to gitlab.inria.fr.
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Thu, 28 Nov 2024 22:24:35 +0100

aevol (5.0+ds-3ubuntu1) oracular; urgency=medium

  * debian/patches/fix-buffer-overflow.patch: avoid possible buffer
    overflows.  Closes LP: #2071412.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 06 Sep 2024 07:57:48 -0700

aevol (5.0+ds-3build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:45:36 +0100

aevol (5.0+ds-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * Do not call AM_INIT_AUTOMAKE twice
    Closes: #998479
  * Standards-Version: 4.6.0 (routine-update)

  [ Étienne Mollier ]
  * Remove now unneeded maintainer manual pages.
  * Add groff-message.patch to fix multiple typos in the comment marker '.\"'.

 -- Étienne Mollier <emollier@debian.org>  Fri, 05 Nov 2021 22:39:02 +0100

aevol (5.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 17 Dec 2020 15:53:43 +0100

aevol (5.0+ds-1) unstable; urgency=medium

  * Team upload.
  * Strip m4 files and once at stripping unnneded autogenerated files
    from automake
    Closes: #933628
  * Build-Depends: libopenmpi-dev
  * Build-Depends: autoconf-archive
  * Remove debug code from autopkgtest

 -- Andreas Tille <tille@debian.org>  Thu, 01 Aug 2019 13:20:27 +0200

aevol (5.0-3) unstable; urgency=medium

  * Team upload.

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.

  [ Andreas Tille ]
  * Add copyright for src/libaevol/SFMT-src-1.4
  * debhelper-compat 12
  * Standards-Version: 4.4.0

  [ Saira Hussain ]
  * Add autopkgtest

 -- Saira Hussain <saira.h0213@zoho.com>  Thu, 25 Jul 2019 09:13:49 +0100

aevol (5.0-2) unstable; urgency=medium

  * Team upload.
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Tue, 25 Sep 2018 11:05:21 +0200

## aevol 5.0+ds

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,19 @@
 Uploaders: David Parsons <david.parsons@inria.fr>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 13),
                zlib1g-dev,
                libx11-dev,
                libboost-dev,
                libboost-system-dev,
-               libboost-filesystem-dev
-Standards-Version: 4.1.0
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/aevol.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/aevol.git
+               libboost-filesystem-dev,
+               mpi-default-dev,
+               autoconf-archive
+Standards-Version: 4.7.0
+Vcs-Browser: https://salsa.debian.org/med-team/aevol
+Vcs-Git: https://salsa.debian.org/med-team/aevol.git
 Homepage: http://www.aevol.fr/
+Rules-Requires-Root: no
 
 Package: aevol
 Architecture: any

=== debian/watch ===
version=4
opts=" \
	mode=git, \
	repacksuffix=+ds, \
	dversionmangle=auto, \
	repack, \
	compression=xz \
" \
https://gitlab.inria.fr/aevol/aevol.git \
refs/tags/v?(\d[\.\d]+)

## aevol 9.3.0

=== debian/changelog ===
aevol (9.3.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * d/watch: version=5
  * Drop libboost-system-dev from Build-Depends
    Closes: #1127160
  * Standards-Version: 4.7.3 (routine-update)
  * Remove Priority field to comply with Debian Policy 4.7.3 (routine-
    update)
  * Reorder Files paragraphs in debian/copyright by directory depth.
  * Use secure URI in Homepage field.
  * Remove duplicate values for fields Author, Author, Author, Entry, Entry,
    Name, Title in debian/upstream/metadata.
  * Build-Depends: cmake, nlohmann-json3-dev, googletest, libgtest-dev
  * d/copyright: No need to remove files any more

 -- Andreas Tille <tille@debian.org>  Tue, 10 Feb 2026 08:19:02 +0100

=== debian/control ===
--- 
+++ 
@@ -2,19 +2,20 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: David Parsons <david.parsons@inria.fr>
 Section: science
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               cmake,
                zlib1g-dev,
                libx11-dev,
                libboost-dev,
-               libboost-system-dev,
                libboost-filesystem-dev,
                mpi-default-dev,
-               autoconf-archive
-Standards-Version: 4.7.0
+               nlohmann-json3-dev,
+               googletest,
+               libgtest-dev
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/aevol
 Vcs-Git: https://salsa.debian.org/med-team/aevol.git
-Homepage: http://www.aevol.fr/
+Homepage: https://www.aevol.fr/
 Rules-Requires-Root: no
 
 Package: aevol

=== debian/rules ===
--- 
+++ 
@@ -8,3 +8,6 @@
 
 %:
 	dh $@
+
+override_dh_auto_test:
+	PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/bin:$(PATH) dh_auto_test

=== debian/watch ===
Version: 5

Source: https://gitlab.inria.fr/aevol/aevol.git
Matching-Pattern: refs/tags/@ANY_VERSION@
Mode: git
